=== debian/changelog ===
ball (1.4.0-4) unstable; urgency=low

  * Documentation packages are in conflict with past version
    (Closes: #631911)
  * Removed (redundant) conflict of ballview to itself
  * Helped quirk in descrition (Closes: #598081)

 -- Steffen Moeller <moeller@debian.org>  Fri, 22 Jul 2011 16:41:02 +0200

ball (1.4.0-3) unstable; urgency=low

  * Added -fpermissive to compiler flags to avoid "narrowing" error

 -- Steffen Moeller <moeller@debian.org>  Wed, 20 Jul 2011 17:47:51 +0200

ball (1.4.0-2) unstable; urgency=low

  * Addressing build failures (Closes: #615670, #631999)
    - removed -j2 in build instructions (Closes: #632483)
    - added texlive-recommends not covered by doxygen-latex

 -- Steffen Moeller <moeller@debian.org>  Wed, 20 Jul 2011 15:19:18 +0200

ball (1.4.0-1) unstable; urgency=low

  [Andreas]
  * Updated to new upstream release 1.4.0
  * Cherry-pick upstream patch for linguist files
  * Cherry-pick upstream patch for new DSO linking scheme
  * Updated policy to 3.9.2
  * Split out arch-independent data package
  * Depend on libgl1-mesa-glx instead of libgl1-mesa-swx11
  * Introduce suitable conflicts against older versions where necessary
  * Install cmake BALL exports and config
  * build-depend on doxygen-latex instead of texlive-* (Closes: 616200)
  * Split build dependencies into Build-Deps and Build-Deps-Indep
  [Steffen]
  * Moved all build instructions to debian/rules.
  * Corrected email address

 -- Andreas Hildebrandt <ahildebr@uni-mainz.de>  Tue, 21 Jun 2011 18:29:51 +0200

ball (1.3.2-3) UNRELEASED; urgency=low

  [Steffen Moeller]
  * Updated policy to 3.8.4 (no changes required)
  * Added libgl1-mesa-swx11 explicitly as a dependency to ballview
  [Andreas Hildebrandt]
  * Depend on python-sip-dev instead of python-sip4-dev (Closes: #611072)

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Tue, 01 Mar 2011 08:30:58 +0100

ball (1.3.2-2) unstable; urgency=low

  [Andreas Hildebrandt]
  * Improvements for CMake build system (Closes: 546311)
  * Some fixes for less common architectures and fixes in the sip dependencies
   (Closes: 565694)
  [Jonathan Wiltshire]
  * Depend on python-support and call dh_pysupport in debian/rules.
    Let python-support decide dependencies for python-ball and python-ballview.
    (Closes: #566036)

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Thu, 11 Feb 2010 22:15:09 +0100

ball (1.3.2-1) unstable; urgency=low

  * Updated to new upstream release 1.3.2

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Tue, 19 Jan 2010 12:34:33 +0100

ball (1.3.1-2) unstable; urgency=low

  * Add python-sip4 as an explicit build-dependency (fixes an FTBFS)

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Tue, 12 Jan 2010 10:25:36 +0100

ball (1.3.1-1) unstable; urgency=low

  * Updated to new upstream release 1.3.1 (Closes: 551241)
  * Switched from autoconf to CMake (Closes: 552809)

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Fri, 18 Dec 2009 14:20:08 +0100

ball (1.3.0-2) UNRELEASED; urgency=low

  [ Andreas Hildebrandt ]
  * Increased dependency to python-sip4 to version 4.8.2, which
    would need to be adjusted for lenny (4.7.2). The real (unexpressable)
    dependency is to have the same version at build- and run-time.  [Steffen]

  [ Charles Plessy ]
  * Documented informations in ‘debian/upstream-metadata.yaml’.

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Thu, 17 Sep 2009 22:30:28 +0200

ball (1.3.0-1) unstable; urgency=low

  * New upstream release 
  * BALL no longer uses gSoap (Closes: #542215)
  * Added s390 to list of supported processors (Closes: #546311)
  * Fixed broken maintainer address (Closes: #544932)
  * Updated policy-compliance to 3.8.3 (no changes reguired)
  * Updated build-dependencies to demand more recent libtool

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Thu, 17 Sep 2009 22:30:28 +0200

ball (1.3+rc2-1) unstable; urgency=low

  * Removed debian/copyright entries for files no longer in the repository
  * Updated to new upstream release candidate
  * Removed build-dependency on libboost-asio-dev (Closes: #542251)
  * Some small packaging improvements

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Thu, 17 Sep 2009 22:25:51 +0200

ball (1.3+beta2.1-2) unstable; urgency=low

  * Re-upload upon initial rejection to improve debian/copyright (Closes: #407665)
  * Improved Doc-Base 
  * Eliminated two lintian warnings

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Sun, 16 Aug 2009 01:23:30 +0200

ball (1.3+beta2.1-1) UNRELEASED; urgency=low

  * Preparing for new upstream version 1.3 (Closes: #407665)
  * Improvements for Debian packaging
    - providing VIEW-independent and -dependent debs
    - corrected for problematic copyright statements

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Mon, 6 Jul 2009 17:43:00 +0100

ball (1.2-1) UNRELEASED; urgency=low

  * Initial packaging

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Sun, 16 Nov 2008 20:24:32 +0100
