=== debian/control ===
Source: ball
Section: science
Priority: optional
Maintainer: Andreas Hildebrandt <ahildebr@uni-mainz.de>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 5), 
 qt4-dev-tools, libqt4-dev, libqt4-gui, libqt4-opengl,
 libqt4-opengl-dev, libqt4-sql, libqt4-network, 
 python-sip-dev (>= 4.8.2), flex, bison, cmake, libglew1.5-dev|libglew-dev, 
 libfftw3-dev, libgsl0-dev, python-dev (>= 2.4), libxrender-dev,
 libboost-dev, libboost-iostreams-dev, libboost-thread-dev, 
 libboost-math-dev | libboost-dev (<< 1.37), libboost-system-dev | libboost-dev (<< 1.37),
 libasio-dev, libboost-regex-dev, libxmu-dev, tidy,
 gs-common, graphviz, chrpath, python-support (>= 0.90.0)
Build-Depends-Indep: texlive-fonts-recommended,
 doxygen-latex|doxygen, doxygen-latex|latex-xcolor,
 doxygen-latex|texlive-extra-utils, doxygen-latex|texlive-latex-extra
XS-Python-Version: all
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/debian-med/ball.git
Vcs-Browser: http://git.debian.org/?p=debian-med/ball.git
Homepage: http://www.ballview.org

Package: libball1.4-data
Section: science
Architecture: all
Depends: ${misc:Depends}
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the data files (force field parameters, fragment
 data bases, etc) necessary for using BALL.

Package: libball1.4
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libball1.4-data
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view - independent parts of BALL (libBALL,
 data directories et al., except for libVIEW) and can be installed on
 machines without X11.

Package: libball1.4-dev
Section: libdevel
Architecture: any
Depends: libball1.4 (= ${binary:Version}), ${misc:Depends}
Conflicts: libball1.3-dev
Recommends: libball1.4-doc
Description: Header files for the Biochemical Algorithms Library
 This package comprises the header files allowing to create
 one's own applications with the BALL library.

Package: libballview1.4
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Biochemical Algorithms Library, VIEW framework
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view parts of BALL (libVIEW). Those are
 required for molecular visualization and for running BALLView.

Package: libballview1.4-dev
Section: libdevel
Architecture: any
Depends: libballview1.4 (= ${binary:Version}), ${misc:Depends}
Conflicts: libballview1.3-dev
Recommends: libball1.4-doc
Description: Header files for the VIEW part of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package comprises the header files allowing to create one's own 
 applications with the VIEW framework of the BALL library.

Package: python-ball
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, ${sip:Depends}, 
 libball1.4, ${misc:Depends}
Conflicts: python-ball (<< ${binary:Version})
Description: Python bindings for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-independent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: python-ballview
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, ${sip:Depends}, 
 libball1.4, libballview1.4, python-ball (= ${binary:Version}), ${misc:Depends}
Conflicts: python-ballview (<< ${binary:Version})
Description: Python bindings for VIEW-parts of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-dependent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: ballview
Section: science
Architecture: any
Depends: ${shlibs:Depends}, libgl1-mesa-glx|libgl1, libball1.4, libballview1.4, python-ball,
 python-ballview, ${misc:Depends}
Description: free molecular modeling and molecular graphics tool
 BALLView provides fast OpenGL-based visualization of molecular structures, 
 molecular mechanics methods (minimization, MD simulation using the 
 AMBER, CHARMM, and MMFF94 force fields), calculation and visualization 
 of electrostatic properties (FDPB) and molecular editing features.
 .
 BALLView can be considered a graphical user interface on the basis of
 BALL (Biochemical Algorithms Library) with a focus on the most common
 demands of protein chemists and biophysicists in particular.  It is
 developed in the groups of Hans-Peter Lenhof (Saarland University,
 Saarbruecken, Germany) and Oliver Kohlbacher (University of Tuebingen,
 Germany). BALL is an application framework in C++ that has been
 specifically designed for rapid software development in Molecular
 Modeling and Computational Molecular Biology.  It provides an extensive
 set of data structures as well as classes for Molecular Mechanics,
 advanced solvation methods, comparison and analysis of protein
 structures, file import/export, and visualization.

Package: libball1.4-doc
Architecture: all
Section: doc
Depends: libball1.4, ${misc:Depends}
Conflicts: libball1.3-doc
Description: documentation for the BALL library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.

Package: ballview-dbg
Architecture: any
Priority: extra
Section: debug
Depends: python-ballview, ballview, ${misc:Depends}
Description: debug symbols for BALL and VIEW libraries
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.
 .
 This package contains all the extra information on the libraries of
 BALL, BALLView and the Python wrappers to help debuggers like GDB to
 interpret a core dump. This is tremendously useful for debugging and
 maybe even more so for the communication between the user of this
 package and upstream when something goes wrong.
