## ball 1.4.1%2B20111206

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
-export CFLAGS = -Wall -g -Wno-unused-variable -fpermissive
+export CFLAGS = -Wall -g -Wno-unused-variable -fpermissive -Wno-format-security 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 	CFLAGS += -O0
 else
@@ -67,6 +67,7 @@
 	find . -name "*.o" | xargs -r rm
 	find . -type l | xargs -r rm
 	find doc/TUTORIAL/ -name "tutorial.*" | egrep -v ".(tex|bib)$$" |xargs -r rm 
+	find . -name "*.doc" -delete
 
 	dh_clean build-stamp configure-stamp build-arch-stamp build-indep-stamp
 
@@ -94,7 +95,7 @@
 	# debian needs the logo in the ballview - package, not in the libball
 	cp $(BALL_INSTALL_PATH)/usr/share/BALL/data/graphics/ballview*.xpm debian/ballview/usr/share/pixmaps/
 
-	cp -r $(CURDIR)/source/EXAMPLES/PYTHON    debian/python-ball/usr/share/BALL-$(SOVERSION)
+	cp -r source/EXAMPLES/PYTHON    debian/python-ball/usr/share/BALL-$(SOVERSION)
 	cp $(BALL_INSTALL_PATH)/usr/lib/BALL.py       debian/python-ball/usr/$(PYTHON_SITE_PATH)
 	cp $(BALL_INSTALL_PATH)/usr/lib/BALLCore.so   debian/python-ball/usr/$(PYTHON_SITE_PATH)
 	cp $(BALL_INSTALL_PATH)/usr/lib/VIEW.so       debian/python-ballview/usr/$(PYTHON_SITE_PATH)
